#include <glib.h>
#include <SDL.h>
#include "struct.h"
#include "def.h"

extern struct conteur_struct conteur;
guint32 now,before;

inline gint niveau_bruit(guint nb_sup_seuil)
{
  if (nb_sup_seuil > BRUIT_3)
    return 3;
  else if (nb_sup_seuil > BRUIT_2)
    return 2;
  else
    return 1;
}

inline void ips(void)
{
  if(conteur.ips==25)
    {
      now = SDL_GetTicks(); 
      printf("FPS :%f\n",25*1000/((float) now-(float) before) ); 
      conteur.fps= (gint) 25*1000/((float) now-(float) before);

      if (conteur.fps<conteur.fps_min)
	conteur.fps_min = conteur.fps;
      if (conteur.general>25*10)
	conteur.fps_min+=1;
    
      before = now;

      conteur.ips=0;	

      if (conteur.general<50)
	conteur.fps=25;
    }   

}

guint bruit(gint16 data[2][512], gint seuil)
{
  gint16 i;
  guint nb_sup_seuil=0;
  seuil = seuil<<8;
  for (i=0; i<512; i++)
    {
      if (data[0][i] > seuil)
	nb_sup_seuil++;
    }
  conteur.nb_sup50 = nb_sup_seuil;
  return nb_sup_seuil;
}

guint detection_mode_reprise(guint nb_sup_seuil)
{
  guint8 i;
  gint nb_niv_1=0,nb_niv_2=0,temp;

  if (niveau_bruit(nb_sup_seuil) == 3)
    {
      for (i=0; i<50; i++)
	{
	  temp=conteur.history[conteur.hist_index-50+i];
	  if (temp > BRUIT_1 && temp <= BRUIT_2)
	    nb_niv_1++;
	  if (temp > BRUIT_2)
	    nb_niv_2++;
	}
      
    /*  printf ("Ratio %f ni_1 %i\n",(float) nb_niv_1/nb_niv_2,nb_niv_1);*/

      if( (float) nb_niv_1/nb_niv_2 >0.5)
	return 1;
      else
	return 0;
    }
  else
    return 0;
}

