#include <glib.h>
#include <stdlib.h>
#include <math.h>
#include <SDL.h>
#include "def.h"
#include "struct.h"
#include "detection.h"

#define MAXE(a,b) ( (a) > (b) ? (b) : (a)) 
#define CARRE 0
#define GALAXIE 1
#define GALAXIE2 2
long int random (void);

extern SDL_Color colors_orig[256][3], colors_used[256];
extern SDL_Surface *screen;
extern gint resx, resy, xres2, yres2;
extern struct conteur_struct conteur;

/*
inline gint
maxe (gint valeur, gint maxi)
{
  if (valeur > maxi)
    return maxi;
  else
    return valeur;
}
*/
inline void
tracer_point_add (guint8 * buffer, gint x, gint y, guint8 color)
{
  guint8 *point;

 /*  goto non; */

  if (x >= xres2 || x <= -xres2 || y >= yres2 || y <= -yres2)
    goto non;

  point = buffer + (-y + yres2) * resx + x + xres2;
  
  *point = MAXE (color + *point, 255);

non:
  ;

}

inline void
perm (gint * one, gint * two)
{
  gint permu;

  permu = *one;
  *one = *two;
  *two = permu;
}

void
cercle (guint8 * buffer, gint h, gint k, gint y, guint8 color)
{
  gint x = -1, d = 3 - 2 * y;

  while (x <= y)
    {
      if (d < 0)
	{
	  d += 4 * x + 6;
	  x++;
	}
      else
	{
	  d += 4 * (x - y) + 10;
	  x++;
	  y--;
	}
      tracer_point_add (buffer, h + x, y + k, color);
      tracer_point_add (buffer, h + y, x + k, color);
      tracer_point_add (buffer, h - y, x + k, color);
      tracer_point_add (buffer, h - x, y + k, color);
      tracer_point_add (buffer, h - x, -y + k, color);
      tracer_point_add (buffer, h - y, -x + k, color);
      tracer_point_add (buffer, h + y, -x + k, color);
      tracer_point_add (buffer, h + x, -y + k, color);
    }
}

void
boule_random (guint8 * buffer, gint x, gint y, gint r, guint8 color)
{
  gint i, j, ecart = (gint) rand()%5+1;
  j = 250;
 for (i = 0; i <= r; i+=ecart)
    {
     
      cercle (buffer, x, y, i, (int) ((float) (j * j) / (256)));
      j = color - color * ((float) i) / r;
    }
}

void
boule (guint8 * buffer, gint x, gint y, gint r, guint8 color)
{
  gint i, j;
  for (i = r; i >= 0; i--)
    {
      j = color - color * ((float) i) / r;
      cercle (buffer, x, y, i, (int) ((float) (j * j) / (256)));
    }
}

void
droite (guint8 * buffer, gint x1, gint y1, gint x2, gint y2, guint8 color)
{

  gint lx, ly, dx, dy;
  gint i, j, k;

  lx = abs(x1-x2);
  ly = abs(y1-y2);
  dx = (x1>x2) ? -1 : 1;
  dy = (y1>y2) ? -1 : 1;
	
  if (lx>ly) 
    {
      for (i=x1,j=y1,k=0;i!=x2;i+=dx,k+=ly) 
	{
	  if (k>=lx) 
	    {
	      k -= lx;
	      j += dy;
	    }

/* 	  point = buffer + (-(j) + yres2) * resx + (i) + xres2; */
/* 	  *point = MAXE (color + *point, 255); */
	  tracer_point_add (buffer, i, j, color);
	}
    } 
  else 
    {
      for (i=y1,j=x1,k=0;i!=y2;i+=dy,k+=lx) 
	{
	  if (k>=ly) 
	    {
	      k -= ly;
	      j += dx;
	    }
/* 	  point = buffer + (-(i) + yres2) * resx + (j) + xres2; */
/* 	  *point = MAXE (color + *point, 255); */
	  tracer_point_add (buffer, j, i, color);
	}
    }	

}

void
rotation_3d (float *x, float *y, float *z, float alpha, float beta,
	     float gamma)
{
  float nx, ny;
  float cosga = cos (gamma), singa = sin (gamma), cosal = cos (alpha), sinal =
    sin (alpha);


  nx = cosga * *x - singa * *y;
  ny = cosal * (singa * *x + cosga * *y) - sinal * *z;
  *z = sinal * (singa * *x + cosga * *y) + cosal * *z;

  *x = nx;
  *y = ny;

}

void
perspective (float *x, float *y, float *z, int persp, int dist_cam)
{
  float foc_cam = 100;
  *x = *x * (foc_cam + persp) / (dist_cam + persp - *z);
  *y = *y * (foc_cam + persp) / (dist_cam + persp - *z);
}

void
grille_3d (guint8 * buffer, gint16 data[2][512], float alpha, float beta,
	   float gamma, int persp, int dist_cam)
{

  float x, y, z, xres2 = (float) (resx >> 1), yres2 = (float) (resy >> 1);
  gint16 ax = 0, ay = 0, ix, iy, i, j, nb_x, nb_y;
 /*  int tx[32][32], ty[32][32]; */
  guint8 color/* [32][32] */;
  nb_x = 32;
  nb_y = 32;

  for (i = 0; i < nb_x; i++)
    {
      for (j = 0; j < nb_y; j++)
	{
	  x = RESFACTXF ((i - ((float) nb_x) / 2) * 10);
	  y = RESFACTYF ((j - ((float) nb_y) / 2) * 10);

	  if (j >= 16)
	    {
	      z = RESFACTXF ((float) (data[0][i + nb_x * (j - 16)]) / 256);
	      color/* [i][j] */ = data[0][i + nb_x * (j - 16)] / 512 + 100;
	    }
	  else
	    {
	      z = RESFACTXF ((float) (data[1][i + nb_x * j]) / 256);
	      color/* [i][j] */ = (data[1][i + nb_x * j]) / 512 + 100;
	    }

	  rotation_3d (&x, &y, &z, alpha, beta, gamma);
	  perspective (&x, &y, &z, persp, dist_cam);

	  if (x >= xres2)
	    {
	      x = xres2 - 1;
	      color/* [i][j] */ = 0;
	    }
	  if (x <= -xres2)
	    {
	      x = -xres2 + 1;
	      color/* [i][j] */ = 0;
	    }
	  if (y >= yres2)
	    {
	      y = yres2 - 1;
	      color/* [i][j] */ = 0;
	    }
	  if (y <= -yres2)
	    {
	      y = -yres2 + 1;
	      color/* [i][j] */ = 0;
	    }

	  ix = (int) x;
	  iy = (int) y;

/* 	  tx[i][j] = ix; */
/* 	  ty[i][j] = iy; */

	  if (j != 0)
	    droite (buffer, ix, iy, ax, ay, color/* [i][j] */);

	  ax = ix;
	  ay = iy;
	}
    }

/*   for (j = 0; j < nb_y; j++) */
/*     { */
/*       for (i = 0; i < nb_x - 1; i++) */
/* 	{ */
/* 	  droite (buffer, tx[i][j], ty[i][j], tx[i + 1][j], ty[i + 1][j], */
/* 		  color[i][j]); */
/* 	} */
/*     } */
}

void
l2_grilles_3d (guint8 * buffer, gint16 data[2][512], float alpha, float beta,
	       float gamma, int persp, int dist_cam)
{

  float x, y, z, xres4 = (float) (resx >> 2);
  float fyres2 = yres2;
  gint16 ax = 0, ay = 0, ix, iy, i, j, nb_x, nb_y;
  int tx[16][16], ty[16][16];
  guint8 color[16][16];
  nb_x = 16;
  nb_y = 16;

  for (i = 0; i < nb_x; i++)
    {
      for (j = 0; j < nb_y; j++)
	{
	  x = RESFACTXF ((i - ((float) nb_x / 2)) * 15);
	  y = RESFACTYF ((j - ((float) nb_y / 2)) * 15);

/* 	  x = RESFACTXF (i*cos((float)j/nb_y*2*PI) * 15); */
/* 	  y = RESFACTYF (i*sin((float)j/nb_y*2*PI) * 15); */

	  z = abs(RESFACTXF ((float) (data[1][i + nb_x * j]) / 256));
	  color[i][j] = data[1][i + nb_x * j] / 512 + 100;

	  rotation_3d (&x, &y, &z, alpha, beta, gamma);
	  perspective (&x, &y, &z, persp, dist_cam);

	  if (x >= xres4)
	    {
	      x = xres4 - 1;
	      color[i][j] = 0;
	    }
	  if (x <= -xres4)
	    {
	      x = -xres4 + 1;
	      color[i][j] = 0;
	    }
	  if (y >= fyres2)
	    {
	      y = fyres2 - 1;
	      color[i][j] = 0;
	    }
	  if (y <= -fyres2)
	    {
	      y = -fyres2 + 1;
	      color[i][j] = 0;
	    }


	  ix = (int) x;
	  iy = (int) y;

	  tx[i][j] = ix;
	  ty[i][j] = iy;

	  if (j != 0)
	    {
	      droite (buffer, ix - xres4, iy, ax - xres4, ay, color[i][j]);
	      droite (buffer, ix + xres4, iy, ax + xres4, ay, color[i][j]);
	    }

	  ax = ix;
	  ay = iy;
	}
    }

  for (j = 0; j < nb_y; j++)
    {
      for (i = 0; i < nb_x - 1; i++)
	{
	  droite (buffer, tx[i][j] - xres4, ty[i][j], tx[i + 1][j] - xres4,
		  ty[i + 1][j], color[i][j]);
	  droite (buffer, tx[i][j] + xres4, ty[i][j], tx[i + 1][j] + xres4,
		  ty[i + 1][j], color[i][j]);
	}
    }
}
/* l2_grilles_3d (guint8 * buffer, gint16 data[2][512], float alpha, float beta, */
/* 	       float gamma, int persp, int dist_cam) */
/* { */

/*   float x, y, z; */
/*   gint16 ax = 0, ay = 0, ix, iy, i, nb_x; */
/*   guint8 color[512]; */
/*   nb_x = 512; */

/*   for (i = 0; i < nb_x; i++) */
/*     { */
      
/*       x = RESFACTXF ((float) i/nb_x*cos(sqrt((float)i/nb_x)*2*PI*10) * 200); */
/*       y = RESFACTYF ((float) i/nb_x*sin(sqrt((float)i/nb_x)*2*PI*10) * 200); */
      
/*       z = RESFACTXF ((float) (data[1][i] / 256)+(i>>1)); */
/*       color[i] = (gint8) ((data[1][i])/512); */
      
/*       rotation_3d (&x, &y, &z, alpha, beta, gamma); */
/*       perspective (&x, &y, &z, persp, dist_cam); */
      
      
/*       ix = (int) x; */
/*       iy = (int) y; */
	  
/*       droite (buffer, ix, iy, ax, ay, color[i]); */

/*       ax = ix; */
/*       ay = iy; */
	
/*     } */
  
/* } */

void
burn_3d (guint8 * buffer, gint16 data[2][512], float alpha, float beta,
		float gamma, int persp, int dist_cam, int mode)
{

  float x, y, z, xres2 = (float) (resx >> 1), yres2 = (float) (resy >> 1);
  gint16 ix, iy, i, j, nb_x, nb_y,plus=0;
  nb_x = 10;
  nb_y = 10;

  for (i = 0; i < nb_x; i++)
    {
      for (j = 0; j < nb_y; j++)
	{
	  switch(mode)
	    {
	    case 0: /* galaxie z commande par data */
	      x = RESFACTXF ((float) 25*(i+1)*cos(-i*2*PI/(10*nb_x)+ j*2*PI/nb_y) );
	      y = RESFACTYF ((float) 25*(i+1)*sin(-i*2*PI/(10*nb_x)+ j*2*PI/nb_y) );
	      z = RESFACTXF ((float) (data[1][i + nb_x * j]) / 512);
	      break;
	    case 1: /* galaxie z commande par alpha et spirale par alpha */
	      x = RESFACTXF ((float) 25*(i+1)*cos(i*2*PI/nb_x*cos(alpha)*i+ j*2*PI/nb_y) );
	      y = RESFACTYF ((float) 25*(i+1)*sin(i*2*PI/nb_x*cos(alpha)*i+ j*2*PI/nb_y) );
	      z = RESFACTXF (40*cos(5*alpha));
	      break;
	    case 2: /* forme bizzare */
	      x = RESFACTXF ((float) 25*(i+1)*cos(-i*2*PI/(10*nb_x)+ j*2*PI/nb_y) );
	      y = RESFACTYF ((float) 25*(i+1)*sin(-i*2*PI/(10*nb_x)+ j*2*PI/nb_y) );
	      z = RESFACTXF (60* (cos(j*2*PI/nb_y)+cos(i*2*PI/nb_y)) );
	      break;
	    case 3: /* oeuf */
	      x = RESFACTXF ((float) 130*sin((i+1)*PI/nb_x)*cos(-i*2*PI/(5*nb_x)+ j*2*PI/nb_y) );
	      y = RESFACTYF ((float) 130*sin((i+1)*PI/nb_x)*sin(-i*2*PI/(5*nb_x)+ j*2*PI/nb_y) );
	      z = -RESFACTXF (130*cos((float)i/nb_x*PI) );
	      plus = 0;
	      break;
	    case 4: /* forme bizzare se deforme*/
	      x = RESFACTXF ((float) 25*(i+1)*cos(-i*2*PI/(10*nb_x)+ j*2*PI/nb_y) );
	      y = RESFACTYF ((float) 25*(i+1)*sin(-i*2*PI/(10*nb_x)+ j*2*PI/nb_y) );
	      z = RESFACTXF (60* (cos(j*2*PI/nb_y+alpha)+cos(i*2*PI/nb_y)) );
	      break;
	     /* alpha = 100*PI/180;*/
	    default:
	    }

	  rotation_3d (&x, &y, &z, alpha, beta, gamma);
	  perspective (&x, &y, &z, persp, dist_cam);

	  if (x >= xres2 || x <= -xres2 || y >= yres2 || y <= -yres2)
	    goto non;

	  ix = (gint) x;
	  iy = (gint) y;

	  boule_random (buffer, ix, iy, 20, plus+100);

	non:
	  ;

	}
    }


}

guint8
couleur (gint16 x)
{
  float xf = (float) x, resx2f = (float) resx / 2;
  return (guint8) ((float) -(xf - resx2f) * (xf + resx2f) * 150 /
		   (resx2f * resx2f));
}

guint8 
courbes_palette(guint8 i, gint no_courbe)
{
  switch(no_courbe)
    {
    case 0:
      return (guint8) ((float) (i * i * i) / (256 * 256));
      break;
    case 1:
      return (guint8) ((float) (i * i) / (256));
      break;
    case 2:
      return (guint8) i ;
      break;
/*     case 3: */
/*       return 255 - (guint8) ((float) (i * i * i) / (256 * 256)); */
/*       break; */
/*     case 4: */
/*       return 255 - (guint8) ((float) (i * i) / (256)); */
/*       break; */
/*     case 5: */
/*       return 255 - i; */
/*       break; */
    case 3:
      return 0;
    default:
      break;
    }
  return 0;
}

void
random_palette(void)
{
  gint i,j,k,l;
 /*  gint ugly [ ] = { 322,514,23,550,413,512,152,504,23,150,414,332,142, */
/* 		230,132,552,231,150,31,521,252,300,324,245,224,542, */
/* 		135,244,411,230,320,135,130,531,141,43,45,400,21,24, */
/* 		144,525,14,25,342,422,42,451,213,512,524,144,505, */
/* 		305,51,35,31,540,243,311,430,42,514,13,403,520,332, */
/* 		424,504,532,404,523,310,541,135,34,123,524,244,41, */
/* 		134,114,304,322,444,413,405,503,331,321,31,235,530, */
/* 		440,241,423,313,515,450,442,340,341,301,410,155,522, */
/* 		351,225,145,251,412,351,415,113,421,155,302,452,240, */
/* 		242,233,410,325,323,441,510,340,315,44,431,151,131, */
/* 	        666,140,516,143,600,255,416,303,50,256,32}; */
 
 again_mister:
  ; 
  j=rand()%3,k=rand()%3,l=rand()%3;

  conteur.triplet = j+10*k+100*l;
/*   for ( i = 0; i <sizeof(ugly); i++) */
/*    { */
/*      if (conteur.triplet == ugly[i]) */
/*        { */
/* 	 printf("Ugly mode dectected: re-randomizing\n"); */
/* 	 goto again_mister; */
/* 	} */
/*    } */
  
 /*  if (j==k) */
 /*    if(j==l) */
/*       goto again_mister; */

/*   if ((j>2) || (k>2) || (l>2)  ) */
/*     { */
/*       if (random()%20!=0) */
/* 	 goto again_mister; */

/*       if ((j<=2) || (k<=2) || (l<=2) || (j==6) || (k==6) || (l==6)) */
/* 	{ */
/* 	  printf("Ugly mode dectected: re-randomizing\n"); */
/* 	  goto again_mister; */
/* 	} */
/*     } */

   if ((j==k) || (j==l) || (l==k))
    goto again_mister;

  for(i=0;i<256;i++){
    colors_used[i].r=courbes_palette(i, j);
    colors_used[i].g=courbes_palette(i, k);
    colors_used[i].b=courbes_palette(i, l);
  }

  printf("Switch to color mode %i\n",j+10*k+100*l);
  SDL_SetColors(screen, colors_used, 0, 256);
}

void
courbes (guint8 * buffer, gint16 data[2][512], guint8 color)
{
  gint j, i;

  for (i = 0; i < resx - 1 && i < 511; i++)
    {
      j = i - 256;
      droite (buffer, j, data[0][i] / (256) + resy / 6, j + 1,
	      data[0][i + 1] / (256) + resy / 6, couleur (j));
      droite (buffer, j, data[1][i] / (256) - resy / 6, j + 1,
	      data[1][i + 1] / (256) - resy / 6, couleur (j));
    }
}

/*
void
mix_palette (guint8 pal_start, guint8 pal_end, float landa)
{
  guint c;
  for (c = 0; c < 256; c++)
    {
      colors_used[c].r =
	(guint8) colors_orig[c][pal_end].r * landa +
	colors_orig[c][pal_start].r * (1 - landa);
      colors_used[c].g =
	(guint8) colors_orig[c][pal_end].g * landa +
	colors_orig[c][pal_start].g * (1 - landa);
      colors_used[c].b =
	(guint8) colors_orig[c][pal_end].b * landa +
	colors_orig[c][pal_start].b * (1 - landa);

    }
  SDL_SetColors (screen, colors_used, 0, 256);
}

float
transition (guint noimage, float nbimages, guint no_trans)
{
  return 0.5 - 0.5 * cos (noimage / nbimages * 3 * PI);
}
*/

void
sinus_rect (guint8 * buffer, gint k)
{
  float fk = k;
  boule (buffer, RESFACTXF (250 * cos (fk / 25)),
	 RESFACTYF (100 * sin (2 * fk / 25)), RESFACTXF (100), 200);
  boule (buffer, RESFACTXF (-250 * cos (fk / 25)),
	 RESFACTYF (100 * sin (2 * fk / 25)), RESFACTXF (100), 200);
}



/*
void rectangle(guint8 *buffer, gint x, gint y, gint weight , gint height, guint8 color)
{
  gint i,j;

  for (i=-weight/2; i<weight/2; i++)
    for (j=-height/2; j<height/2; j++)
      {
	*(buffer+ (-(j+y)+resy/2)*resx+(x+i)+resx/2)=maxe(*(buffer+ (-(j+y)+resy/2)*resx+(x+i)+resx/2)+180 -abs(2*i)-abs(2*j),255);
      }
}
*/
  /*  
     nx = *x;
     ny = cos(alpha)**y - sin(alpha)**z;
     nz = sin(alpha)**y + cos(alpha)**z;

     *x = cos(beta)*nx - sin(beta)*nz;
     *y = ny;
     *z = sin(beta)*nx + cos(beta)*nz; 

     nx = cos(gamma)**x - sin(gamma)**y;
     ny = sin(gamma)**x + cos(gamma)**y;
     nz = *z; */




/*
  void equalizer(guint8 *buffer,gint16 data[2][512])
  {
  float fx,fy;
  int i,y,j;
  for (j=0; j<128; j++)
  {
  for (i=0;i<4;i++)
  {
  y = data[0][j]/(256);
  *(buffer+(-y+resy/2)*resx+4*j+i)=255;
  *(buffer+(-y+1+resy/2)*resx+4*j+i)=255;
  }
  }
  }*/



/*
static void jess_render_freq(gint16 data[2][512])
{
 
}
*/

    /*
       if(bpp!=1)
       {   
       buf2= buffer2; buf = buffer;
       for (j=0;j<resy;j++)
       { 
       pix= pixel +j*pitch +2 -bpp;
       for (i=0;i<resx;i++)
       {
       pix+=bpp ;
       *pix = *(buf2++); 
       *(buf++) = dim[*(buf2)] ; 
       }
       }
       }
       else */
